package de.joethei.hs.java2.praktikum1;

import java.util.logging.Logger;

public class GrosseZahl {

    private static Logger logger = Logger.getLogger(GrosseZahl.class.getName());

    private int Zahl[];

    public GrosseZahl(String d) {
        boolean korrekteEingabe = true;
        for (int i = 0; i < d.length(); i++) {
            if (Integer.parseInt(String.valueOf(d.charAt(i))) < 0 || Integer.parseInt(String.valueOf(d.charAt(i))) > 9) {
                korrekteEingabe = false;
            }
        }
        if (korrekteEingabe) {
            Zahl = new int[d.length()];
            for (int w = 0; w < d.length(); w++) {
                Zahl[w] = Integer.parseInt(String.valueOf(d.charAt(w)));
            }

        } else {
            System.out.println("Incorrect Input!");
        }
    }

    public GrosseZahl(int i) {
        String intZahl = Integer.toString(i);
        Zahl = new int[intZahl.length()];
        for (int w = 0; w < intZahl.length(); w++) {
            Zahl[w] = Integer.parseInt(String.valueOf(intZahl.charAt(w)));
        }
    }

    private GrosseZahl(int[] zahl) {
        this.Zahl = zahl;
    }

    public String toString() {
        StringBuilder rueckgabe = new StringBuilder();
        for (int aZahl : Zahl) {
            rueckgabe.append(Integer.toString(aZahl));
        }
        return rueckgabe.toString();
    }

    private int toInt() {
        int IntZahl = 0;
        for (int aZahl : Zahl) {
            IntZahl *= 10;
            IntZahl += aZahl;
        }
        return IntZahl;
    }

    public boolean less(GrosseZahl b) {
        if(this.equals(b)) return false;
        if (this.Zahl.length < b.Zahl.length) return true;
        if (this.Zahl.length > b.Zahl.length) return false;

        for (int i = this.Zahl.length -1; i >= 0; i--) {
            if (this.Zahl[i] > b.Zahl[i]) return false;
        }
        return true;
    }

    public GrosseZahl add(GrosseZahl b) {
        int IntZahl = 0;
        for (int aZahl : Zahl) {
            IntZahl *= 10;
            IntZahl += aZahl;
        }
        IntZahl += b.toInt();
        return new GrosseZahl(IntZahl);
    }

    public GrosseZahl sub(GrosseZahl b) {

        return null;
    }

    public GrosseZahl mult(GrosseZahl b) {
        int IntZahl = 0;
        for (int aZahl : Zahl) {
            IntZahl *= 10;
            IntZahl += aZahl;
        }
        IntZahl *= b.toInt();
        return new GrosseZahl(IntZahl);
    }

    /*
    public GrosseZahl ggT(GrosseZahl b) {
        int IntZahl = 0;
        for (int aZahl : Zahl) {
            IntZahl *= 10;
            IntZahl += aZahl;
        }
        if (IntZahl == b.toInt()) {
            return b;
        } else if (this.less(b)) {
            GrosseZahl c = new GrosseZahl(b.toInt() - IntZahl);
            return this.ggT(c);
        } else {
            GrosseZahl c = new GrosseZahl(Math.abs(IntZahl - b.toInt()));
            return c.ggT(b);
        }
    }
    */

    public GrosseZahl ggT(GrosseZahl b) {
        if(this.equals(b)) return this;
        if(this.less(b)) return this.ggT(b.sub(this));
        else return this.sub(b).ggT(b);
    }

    @Override
    public boolean equals(Object o) {
        if(o instanceof GrosseZahl) {
            GrosseZahl tmp = (GrosseZahl) o;
            if(tmp.Zahl.length == this.Zahl.length) {
                for(int i = this.Zahl.length - 1; i >= 0; i--) {
                    if(tmp.Zahl[i] != this.Zahl[i]) return false;
                }
                return true;
            }else return false;
        }
        return false;
    }
}
